//+------------------------------------------------------------------+
//|                                          RandomTickGenerator.mq4 |
//|                      Copyright  2009, C-4, All Rights Reserved. |
//|                                                   vs-box@mail.ru |
//+------------------------------------------------------------------+

//      .     RND 1.0000 
// 0.0001    ,   0.0001    

#property copyright "Copyright  2009, C-4, All Rights Reserved."
#property link      "vs-box@mail.ru"
#property show_inputs

extern int tiks=10000;                 //    
extern int i_bars=1000;                //- 
extern int SetRandGenerator=49500;
extern int DarkEnergyPercent=0;

int handle;

double RND=1.0000;
double rnd_high=1.0,
       rnd_low=1.0,
       rnd_close=1.0,
       rnd_open=1.0;

double rez;
int sum;

void init()
{
   handle=FileOpen("RandomTikGenrator-"+i_bars+"_t"+tiks+".csv",FILE_WRITE|FILE_CSV, ";");
   if(handle==0)Print("   , :", GetLastError());
   MathSrand(SetRandGenerator);
   if(DarkEnergyPercent==0||tiks==0)rez=-1;
   else rez=MathRound(tiks/(tiks*DarkEnergyPercent/100.0));
   Print(rez);
}

int start()
{
   for(int k=0;k<i_bars;k++){
      rnd_open=RND;
      rnd_low=RND;
      rnd_high=RND;
      rnd_close=RND;
      for(int i=1;i<tiks;i++){
         if(DarkEnergy(i)==true){RND+=0.001;sum++;}
         else{
            if(MathMod(MathRand(),2)==1)RND+=0.0001;
            else RND-=0.0001;
         }
         if(RND>rnd_high)rnd_high=RND;
         if(RND<rnd_low)rnd_low=RND;
      }
      rnd_close=RND;
      FileWrite(handle,DoubleToStr(rnd_open,4),DoubleToStr(rnd_high,4),DoubleToStr(rnd_low,4),DoubleToStr(rnd_close,4));
   }
   return(0);
}

bool DarkEnergy(int i)
{
   if(rez==-1)return(false);
   //Print(MathMod(i,rez), " ", rez);
   if(MathMod(i,rez)==0)return(true);
   else return(false);
}

void deinit()
{
   Print("  .      ", sum);
   FileClose(handle);
}

