//+------------------------------------------------------------------+
//|                                          RandomTickGenerator.mq4 |
//|                      Copyright  2009, C-4, All Rights Reserved. |
//|                                                   vs-box@mail.ru |
//+------------------------------------------------------------------+

//      .     RND 1.0000 
// 0.0001    ,   0.0001    

#property copyright "Copyright  2009, C-4, All Rights Reserved."
#property link      "vs-box@mail.ru"
#property show_inputs

extern int tiks=1000;
extern int SetRandGenerator=49500;
extern int DarkEnergyPercent=0;
int handle;
double RND=1.0000;
double rez;
int sum;

void init()
{
   handle=FileOpen("RandomTikGenrator-"+tiks+".csv",FILE_WRITE|FILE_CSV, ";");
   if(handle==0)Print("   , :", GetLastError());
   MathSrand(SetRandGenerator);
   if(DarkEnergyPercent==0||tiks==0)rez=-1;
   else rez=MathRound(tiks/(tiks*DarkEnergyPercent/100.0));
   Print(rez);
}

int start()
{
   for(int i=1;i<tiks;i++){
      if(DarkEnergy(i)==true){RND+=0.001;sum++;}
      else{
         if(MathMod(MathRand(),2)==1)RND+=0.001;
         else RND-=0.001;
      }
      FileWrite(handle,i,DoubleToStr(RND,4));
   }
   return(0);
}

bool DarkEnergy(int i)
{
   if(rez==-1)return(false);
   //Print(MathMod(i,rez), " ", rez);
   if(MathMod(i,rez)==0)return(true);
   else return(false);
}

void deinit()
{
   Print("  .      ", sum);
   FileClose(handle);
}

